/*
 * Smartcrypt - a tool to encrypt / decrypt files
 * Copyright (C) 2005 Kai Witte
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * For contact information see http://kwitte.dyndns.org/~kwitte/
 */


import javax.crypto.*;
import java.security.*;
import javax.crypto.spec.*;
import java.security.spec.*;

public class TestCase2 {
    public static void main(String[] args) throws Exception {
        SecretKeyFactory pfac = 
            SecretKeyFactory.getInstance("PBEWithMD5AndDES");
        SecretKey sk = pfac.generateSecret(
                new PBEKeySpec("password".toCharArray()));
        PBEParameterSpec pspec = new PBEParameterSpec(
                new byte[] { 3, 4, 27, 9, 4, 9, 27, 100 }, 1024);
        AlgorithmParameters params = AlgorithmParameters.getInstance("PBE");
        params.init(pspec);
        Cipher.getInstance("PBEWithMD5AndDES").init(
                Cipher.ENCRYPT_MODE, sk, params);
    }
}

