package testcase;

import javax.crypto.Cipher;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.PBEParameterSpec;
import java.security.*;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.InvalidParameterSpecException;

public class TripleDESTest {
    private static final String ALGORITHM = "PBEWithMD5AndTripleDES";
    private static final String PASSWORD = "asdfasdf";
    public static final byte[] SALT = new byte[] { 3, 4, 27, 9, 4, 9, 27, 100 };

    public static void main(String[] args) throws NoSuchAlgorithmException,
            InvalidKeySpecException, InvalidParameterSpecException,
            NoSuchPaddingException, InvalidAlgorithmParameterException {
        SecretKeyFactory pfac =
            SecretKeyFactory.getInstance(ALGORITHM);
        Key key = pfac.generateSecret(new PBEKeySpec(PASSWORD.toCharArray()));
        PBEParameterSpec pspec = new PBEParameterSpec(SALT, 1024);
        AlgorithmParameters params = AlgorithmParameters.getInstance("PBE");
        params.init(pspec);
        Cipher cipher = Cipher.getInstance(ALGORITHM);

        // The unexpected error occurs here.
        // Expected: no output and clean return of main method
        // Actual: "java.security.InvalidKeyException: Illegal key size"
        try {
            cipher.init(Cipher.ENCRYPT_MODE, key, params);
        } catch (InvalidKeyException ike) {
            throw new AssertionError(ike);
        }
    }
}
