/*
 * Smartcrypt - a tool to encrypt / decrypt files
 * Copyright (C) 2005 Kai Witte
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * For contact information see http://kwitte.dyndns.org/~kwitte/
 */


package test;

import junit.framework.TestSuite;
import junit.framework.TestCase;
import org.dyndns.kwitte.smartcrypt.CipherFactoryImpl;
import org.dyndns.kwitte.smartcrypt.CipherFactory;

import javax.crypto.Cipher;
import java.security.NoSuchAlgorithmException;
import java.security.InvalidKeyException;

/**
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: 23.12.2004
 * Time: 21:02:16
 * To change this template use File | Settings | File Templates.
 */
public class TestCipher extends TestCase {
    public void testNoSuchAlgorithmException() {
        CipherFactory cf = new CipherFactoryImpl();
        try {
            cf.createCipher("nosuch", "test".toCharArray(), 
                            Cipher.ENCRYPT_MODE, null);
        } catch (NoSuchAlgorithmException nsa) {
            return;
        } catch (InvalidKeyException i) {
            fail();
        }
        fail();
    }

    // unclear when this exception can occur
//    public void testInvalidKeyException() {
//        CipherFactory cf = new CipherFactoryImpl();
//        try {
//            // passphrase too short
//            cf.createCipher("PBEWithMD5AndDES", "", Cipher.ENCRYPT_MODE);
//        } catch (InvalidKeyException nsa) {
//            return;
//        } catch (NoSuchAlgorithmException i) {
//            fail();
//        }
//        fail();
//    }
}
